package org.wikimedia.discovery.cirrus.updater.producer.graph;

import static com.google.common.collect.Maps.newHashMap;
import static java.util.stream.Collectors.groupingBy;
import static org.wikimedia.discovery.cirrus.updater.common.graph.BypassingCirrusDocFetcher.fetchRequired;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.function.BiFunction;
import java.util.function.BinaryOperator;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import java.util.stream.StreamSupport;

import org.wikimedia.discovery.cirrus.updater.common.model.ChangeType;
import org.wikimedia.discovery.cirrus.updater.common.model.UpdateEvent;
import org.wikimedia.discovery.cirrus.updater.common.model.UpdateEvent.TargetDocument;
import org.wikimedia.discovery.cirrus.updater.common.model.UpdateEvent.Update;
import org.wikimedia.discovery.cirrus.updater.common.model.UpdateEvent.Update.UpdateBuilder;

import com.google.common.base.Verify;

import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;

/** Accumulator used to reduce a stream of (windowed) events for a single page. */
public class UpdateEventMerger {

    private static final String UNPREFIXED_PREFIX = "__UNNAMED_GROUPING__";

    /**
     * Sorts events such that the most recent event to the newest revision comes first, events without
     * a rev_id (e.g. rerender) are last.
     */
    private static final Comparator<UpdateEvent> MOST_RECENT_FIRST =
            Comparator.comparing(UpdateEvent::getRevId, Comparator.nullsLast(Comparator.reverseOrder()))
                    .thenComparing(UpdateEvent::getEventTime, Comparator.reverseOrder());

    private int duplicates;

    private final List<UpdateEvent> partials = new ArrayList<>();

    private UpdateEvent primary;
    private UpdateEvent rerender;

    private boolean fromPrivateStream;

    public int getDuplicateCount() {
        return duplicates;
    }

    public int getMergedCount() {
        return primary == null ? Math.max(partials.size() - 1, 0) : partials.size();
    }

    /**
     * Deduplicates indexing events
     *
     * <p>This is essentially a bypassable reduce operation. Events that cannot be deduplicated are
     * passed through untouched. Events that can are reduced such that only the last event to the
     * highest revision id is emitted. Bypassed events are added to the list provided in parameters,
     * the reduced primary event, or null, is returned. This has the effect of separating out a single
     * nullable primary event, which typically comes from mediawiki, and a list of secondary tags
     * update events to be merged into the primary event.
     *
     * <p>The general goal here is to deduplicate over the action space. Revision based updates from
     * mediawiki only do two things: 1) delete the page 2) replace the page with results of cirrusdoc
     * api. Doing any of those actions twice in a row would be pointless, the second action either
     * does nothing or replaces what the prior action did. Similarly, these actions are inverse of
     * each other. A delete after an update, or indexing a full doc after deleting it are equally
     * pointless. In all cases the last action overrides the prior.
     */
    public static UpdateEventMerger create(Iterable<UpdateEvent> windowEvents) {
        return StreamSupport.stream(windowEvents.spliterator(), false)
                .sorted(MOST_RECENT_FIRST)
                .reduce(
                        new UpdateEventMerger(),
                        UpdateEventMerger::merge,
                        UpdateEventMerger::verifySequentialReduce);
    }

    /**
     * Merges multiple revision based index updates.
     *
     * <p>When receiving edit-based events we will likely have the initial edit ({@link #primary})
     * event along with followup events ({@link #partials}), for example, for weighted tags that are
     * generated by other services based on those same edit events.
     *
     * <p>This process merges the partial updates with the initial update.
     *
     * @return if {@link #primary} is set, an {@link Optional} wrapping {@link #primary} with merged
     *     updates, otherwise an empty {@link Optional}
     */
    public Stream<UpdateEvent> get() {
        Stream<UpdateEvent> result;
        if (primary != null) {
            Verify.verify(rerender == null, "Cannot have a revision based event and a rerender");
            if (primary.getChangeType() == ChangeType.PAGE_DELETE || partials.isEmpty()) {
                result = Stream.of(primary);
            } else {
                result =
                        Stream.concat(Stream.of(primary), partials.stream())
                                .reduce(UpdateEventMerger::merge)
                                .map(Stream::of)
                                .orElseGet(Stream::empty);
            }
        } else {
            // We don't attempt to merge re-renders with partial updates
            // First reason is that it's very unlikely that in the time of the window we get a partial
            // update and a rerender for the same the page.
            // Secondly since we want to refresh the redirect arrays during re-renders we might not be
            // able to merge it with incremental redirect updates.
            Stream<UpdateEvent> partialUpdates =
                    partials.stream()
                            .reduce(UpdateEventMerger::merge)
                            .map(Collections::singletonList)
                            .orElseGet(Collections::emptyList)
                            .stream();
            result =
                    Stream.concat(partialUpdates, rerender != null ? Stream.of(rerender) : Stream.empty());
        }
        return result.map(
                event -> {
                    event.setFromPrivateStream(fromPrivateStream);
                    return event;
                });
    }

    /**
     * Combiner to be used with {@link Stream#reduce(Object, BiFunction, BinaryOperator)}.
     *
     * @param self the reduction result
     * @param event the event to be merged in
     * @return {@code self}
     */
    @SuppressWarnings("CyclomaticComplexity")
    private static UpdateEventMerger merge(UpdateEventMerger self, UpdateEvent event) {
        // If any input event is from a private stream all output events will be similarly flagged.
        self.fromPrivateStream = self.fromPrivateStream || event.getFromPrivateStream();
        switch (event.getChangeType()) {
            case TAGS_UPDATE:
            case REDIRECT_UPDATE:
                self.partials.add(event);
                break;
            case PAGE_DELETE:
            case REV_BASED_UPDATE:
                Verify.verify(
                        self.rerender == null,
                        "Processed a rerender event [{}] before a revision based one [{}], this should not happen",
                        self.rerender,
                        event);
                if (self.primary == null) {
                    self.primary = event;
                } else {
                    if (event.getMovedFrom() != null) {
                        // keep the movedFrom target of the oldest event
                        self.primary.setMovedFrom(event.getMovedFrom().toBuilder().build());
                    }
                    ++self.duplicates;
                }
                break;
            case PAGE_RERENDER:
                if (self.primary != null || self.rerender != null) {
                    ++self.duplicates;
                } else {
                    self.rerender = event;
                }
                break;
            case PAGE_RERENDER_UPSERT:
                if (self.primary != null || self.rerender != null) {
                    ++self.duplicates;
                }
                if (self.primary == null
                        && (self.rerender == null
                                || self.rerender.getChangeType() == ChangeType.PAGE_RERENDER)) {
                    self.rerender = event;
                }
                break;
            default:
                throw new UnsupportedOperationException(
                        "Unable to accumulate of type '" + event.getChangeType() + "' (" + event + ")");
        }
        return self;
    }

    /**
     * Combiner to be used with {@link Stream#reduce(Object, BiFunction, BinaryOperator)}.
     *
     * @param primary the primary event to merge in
     * @param partial the partial event to be merged in
     * @return the primary event with merged update
     */
    @SuppressWarnings("checkstyle:IllegalCatch")
    private static UpdateEvent merge(UpdateEvent primary, UpdateEvent partial) {
        try {
            final Update primaryUpdate = primary.getUpdate();
            final Update partialUpdate = partial.getUpdate();

            // Deletes also have a null Update, but those should never make it here
            Verify.verify(
                    fetchRequired(primary) || primaryUpdate != null, "Missing update for primary event");
            Verify.verifyNotNull(partialUpdate, "Missing update for partial event");

            if (primaryUpdate == null) {
                primary.setUpdate(partialUpdate);
                return primary;
            }

            final UpdateBuilder primaryUpdateBuilder = primaryUpdate.toBuilder();
            mergeNoopHints(primaryUpdate, partialUpdate).ifPresent(primaryUpdateBuilder::noopHints);
            mergeWeightedTags(primaryUpdate, partialUpdate).ifPresent(primaryUpdateBuilder::weightedTags);
            mergeRedirectChange(
                            primaryUpdate,
                            partialUpdate,
                            Update::getRedirectRemove,
                            (redirect) ->
                                    primaryUpdate.getRedirectAdd() == null
                                            || !primaryUpdate.getRedirectAdd().contains(redirect))
                    .ifPresent(primaryUpdateBuilder::redirectRemove);
            mergeRedirectChange(
                            primaryUpdate,
                            partialUpdate,
                            Update::getRedirectAdd,
                            (redirect) ->
                                    primaryUpdate.getRedirectRemove() == null
                                            || !primaryUpdate.getRedirectRemove().contains(redirect))
                    .ifPresent(primaryUpdateBuilder::redirectAdd);
            primary.setUpdate(primaryUpdateBuilder.build());
            return primary;
        } catch (RuntimeException e) {
            throw new IllegalArgumentException(
                    "Failed processing merge of primary event ["
                            + primary
                            + "] and partial ["
                            + partial
                            + "]",
                    e);
        }
    }

    private static Optional<Map<String, String>> mergeNoopHints(Update primary, Update partial) {
        if (partial.getNoopHints() != null) {
            final Map<String, String> primaryNoopHints = primary.getNoopHints();
            if (primaryNoopHints != null) {
                final Map<String, String> mergedNoopHints = newHashMap(primaryNoopHints);
                mergedNoopHints.putAll(partial.getNoopHints());
                return Optional.of(mergedNoopHints);
            } else {
                return Optional.of(newHashMap(partial.getNoopHints()));
            }
        }
        return Optional.empty();
    }

    private static Optional<List<String>> mergeWeightedTags(Update primary, Update partial) {
        if (partial.getWeightedTags() != null) {
            if (primary.getWeightedTags() != null) {
                final Map<String, List<String>> mergedWeightedTags =
                        newHashMap(groupWeightedTagsByPrefix(primary.getWeightedTags()));
                groupWeightedTagsByPrefix(partial.getWeightedTags())
                        .forEach(mergedWeightedTags::putIfAbsent);
                return Optional.of(
                        mergedWeightedTags.values().stream()
                                .flatMap(Collection::stream)
                                .collect(Collectors.toList()));
            } else {
                return Optional.of(new ArrayList<>(partial.getWeightedTags()));
            }
        }
        return Optional.empty();
    }

    private static Optional<List<TargetDocument>> mergeRedirectChange(
            Update primary,
            Update partial,
            Function<Update, List<TargetDocument>> extractor,
            Predicate<TargetDocument> addIf) {

        final List<TargetDocument> partialRedirects = extractor.apply(partial);
        if (partialRedirects != null) {
            final List<TargetDocument> primaryRedirects = extractor.apply(primary);
            if (primaryRedirects != null) {
                final List<TargetDocument> mergedRedirectChange = new ArrayList<>(primaryRedirects);
                partialRedirects.stream().filter(addIf).forEach(mergedRedirectChange::add);
                if (mergedRedirectChange.size() > primaryRedirects.size()) {
                    return Optional.of(mergedRedirectChange);
                }
                return Optional.empty();
            }
            return Optional.of(new ArrayList<>(partialRedirects));
        }
        return Optional.empty();
    }

    /**
     * Merge many tags updates into a single update.
     *
     * <p>While the tags are provided as a {@link List List<String>}, when interpreted by the
     * downstream system the tags are grouped by prefix into {@link Map Map<String,List<String>}. When
     * applying sequential tags updates the last update to a prefix always overwrites prior updates,
     * meaning each prefix in the merged result must come from a single event, and that event must be
     * the most recent event.
     *
     * @param weightedTags a collection of tags
     * @return a map grouping {@code weightedTags} by their prefix
     */
    private static Map<String, List<String>> groupWeightedTagsByPrefix(
            Collection<String> weightedTags) {
        return weightedTags.stream().collect(groupingBy(UpdateEventMerger::weightedTagPrefix));
    }

    private static String weightedTagPrefix(String tag) {
        int pos = tag.indexOf('/');
        if (pos == -1) {
            // These shouldn't exist in modern streams, but the downstream superdetectnoop plugin
            // accepts un-prefixed tags.
            return UNPREFIXED_PREFIX;
        }
        return tag.substring(0, pos);
    }

    /**
     * Method to be referenced as {@code combiner} in {@link Stream#reduce(Object,
     * java.util.function.BiFunction, java.util.function.BinaryOperator)}.
     *
     * <p>Since we run in a single-threaded environment (inside k8s), we do not use parallel stream
     * processing and therefore, the {@code combiner} never gets called.
     */
    @SuppressFBWarnings("UP_UNUSED_PARAMETER")
    private static <T> T verifySequentialReduce(T identityA, T identityB) {
        throw new UnsupportedOperationException("must be sequential/non-parallel");
    }
}
